/*
 * grunt-build-info
 * 
 *
 * Copyright (c) 2014 John Stauffer
 */

'use strict';

module.exports = function(grunt) {
  var chalk = require('chalk');

  grunt.registerMultiTask('build_info', 'Generate a build-info.json file.', function() {
    // Merge task-specific and/or target-specific options with these defaults.
    var options = this.options({
      filename: 'build-info.json',
      buildCommit: process.env.GIT_COMMIT || 'N/A',
      buildName: process.env.JOB_NAME || 'local-build',
      buildNumber: process.env.BUILD_NUMBER || '0',
      branchName: process.env.GIT_BRANCH || 'local'
    });
    
    var version = (options['pkg']) ? options['pkg'].version : options['version'];

    var buildInfo = {
      version: version,
      buildCommit: options['buildCommit'],
      buildName: options['buildName'],
      buildNumber: options['buildNumber'],
      branchName: options['branchName']
    };
    
    grunt.file.write( options['filename'], JSON.stringify(buildInfo, null, 4));    
  });

};
